/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function(window, RSVP, rJS, jIO) {
  "use strict";
  rJS(window)

  .declareMethod("parse", function(file_link){
    var gadget = this,
        title;
    return new RSVP.Queue().push(function(){
      return jIO.util.ajax({url : file_link});
    })
      .push(function(file){
        var rss;
        rss = file.currentTarget.responseText;
        title = rss.slice(rss.indexOf("<title>")+7, rss.indexOf("</title>"));
        return gadget.remove_css(rss);
      })
      .push(function(rss_without_css){
        return {title : title, content : rss_without_css};
      });
  })

  .declareMethod("remove_css", function(body){
    /*var doc = new DOMParser().parseFromString(body, "text/html");
    return doc.body.textContent || "";*/
    var regEx = new RegExp('(style="(.*?)"|style=&quot(.*?)&quot)', 'gi');
    return body.replace(regEx, "");
  });

}(window, RSVP, rJS, jIO));
