/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function(window, RSVP, rJS, jIO) {
    "use strict";
    rJS(window)

    .declareMethod("addItem", function(item, key) {
      var list,
          list_item,
          title,
          link,
          link_par,
          body,
          gadget = this;

      list = document.getElementById("mynij-results");
      list_item = document.createElement("LI");

      title = document.createElement("a");
      title.appendChild(document.createTextNode(item.title));
      title.className="title";
      title.href = item.link;
      list_item.appendChild(title);
      
      return this.cut_link(item.link)
        .push(function(cut_link){
          link = document.createElement("a");
          link.appendChild(document.createTextNode(cut_link));
          link.href = item.link;
          link.className = "link";
          link_par = document.createElement('p');
          link_par.appendChild(link);
          list_item.appendChild(link_par);
        })
        .push(function(){
          body = document.createElement('p');
          body.className = "body";
          item.body = new DOMParser().parseFromString(item.body, "text/html").body.textContent || "";
          if (key === "" || item.body === ""){
            body.innerHTML = "";
            list.appendChild(list_item);
          } else {
            return gadget.cut_description(item.body, key)
              .push(function (result){
                var array = [...result.matchAll(key)],
                    i;
                for (i=0; i<array.length; i+=1){
                    result = result.slice(0, array[i].index) + "<b>" + result.slice(array[i].index, array[i].index+array[i][0].length+1) + "</b>" + result.slice(array[i].index+array[i][0].length+1);
                }
                body.innerHTML = result;
                list_item.appendChild(body);
                list.appendChild(list_item);
            });
          } 
        });
      

    })
    
    .declareMethod("show_searx_result", function(item, key){
      var list,
          list_item,
          title,
          link,
          link_par,
          body;
      
      list = document.getElementById("searx-results");
      list_item = document.createElement("li");
      
      title = document.createElement("a");
      title.appendChild(document.createTextNode(item.querySelector('h4.result_header').textContent));
      title.className="title";
      title.href =item.querySelector('div.external-link').textContent;
      list_item.appendChild(title);
      
      link = document.createElement("a");
      link.appendChild(document.createTextNode(item.querySelector('div.external-link').textContent));
      link.href = item.querySelector('div.external-link').textContent;
      link.className = "link";
      link_par = document.createElement("p");
      link_par.appendChild(link);
      list_item.appendChild(link_par);
      
      body = document.createElement("p");
      body.className = "body";
      if (item.querySelector('p.result-content') !== null) body.innerHTML = item.querySelector('p.result-content').outerHTML;
      else body.innerHTML = "";
      list_item.appendChild(body);
      
      list.appendChild(list_item);
    })
    
    .declareMethod("clear", function(){
      var list = document.getElementById("mynij-results");
      while (list.firstChild) {
        list.removeChild(list.firstChild);
      }
      list = document.getElementById("searx-results");
      while (list.firstChild) {
        list.removeChild(list.firstChild);
      }
    })
    
    .declareMethod("cut_description", function(body, key){
      var result = new RegExp('[^.?!]*' + ' ' + key + ' ' + '[^.?!]*[.?!]', 'gm').exec(body);
      if (result === null) {
        result = new RegExp('[^.?!]*[.?!]').exec(body);
        if (result === null) return "";
        else return result[0];
      }
      else return result[0];
    })
    
    .declareMethod("cut_link", function(link){
      if (link === undefined) return "";
      if (link.length > 70) return link.slice(0,70) + "...";
      else return link;
    });

}(window, RSVP, rJS, jIO));