(function (window, document, rJS, RSVP) {
  var gadget;
  rJS(window)
  
  .allowPublicAcquisition("get_server_model", function(){
    return this.state.server_model_gadget;
  })

  .setState({
   server_model_gadget : null,
   client_model_gadget : null,
   parser_gadget : null,
   result_gadget : null,
   to_load: [
     "allemandfacile.rss",
     "anglaisfacile.rss",
     "espagnolfacile.rss",
     "francaisfacile.rss",
     "hgeo_college.rss",
     "histoirencours.rss",
     "italienfacile.rss",
     "lewebpedagogique-lapasserelle.rss",
     "mathematiquesfacile.rss",
     "physique_chimie_college.rss",
     "technologieaucollege27.rss",
     "vivelessvt.rss",
     "bnf.rss",
     "letudiant.rss"
     ]
  })

  .ready(function(){
      var server_model_gadget,
          client_model_gadget,
          result_gadget,
          gadget = this;
    
    return gadget.getDeclaredGadget("server_model")
      .push(function(server_model){
        server_model_gadget = server_model;
      })
      .push(function(){
        return gadget.getDeclaredGadget("client_model");
      })
      .push(function(client_model){
        client_model_gadget = client_model;
      })
      .push(function(){
        return gadget.getDeclaredGadget("result");
      })
      .push(function(result){
        result_gadget = result;
      })
      .push(function(){
        return gadget.getDeclaredGadget("parser");
      })
      .push(function(result){
        return gadget.changeState({
          server_model_gadget : server_model_gadget,
          client_model_gadget : client_model_gadget,
          parser_gadget : result,
          result_gadget : result_gadget
        });
      });
  })
  
  .onStateChange(function (modification_dict){
    var gadget = this;
    return gadget.state.server_model_gadget.loaded()
      .push(function(loaded){
        if (!loaded){
          return gadget.state.server_model_gadget.add_doc("scolaire")
            .push(function(){
              return gadget.state.server_model_gadget.add_index("scolaire");
            })
            .push(function(){
              var promise_list = [],
                  i;
              for (i = 0; i < gadget.state.to_load.length; i++){
                promise_list.push(gadget.state.parser_gadget.parse("./test-files/" + gadget.state.to_load[i]));
              }
              return RSVP.all(promise_list);
            })
            .push(function(parsed_file_items){
              var i,
                  promise_list = [],
                  queue = new RSVP.Queue(),
                  add_to_feed;
              add_to_feed = function(doc_name, feed){
                queue.push(function(){
                  return gadget.state.server_model_gadget.add_feed_to_doc(doc_name, feed);
                });                  
              };
              for (i=0; i<parsed_file_items.length; i+=1){
                add_to_feed("scolaire", {title : parsed_file_items[i].title, content : parsed_file_items[i].content});
              }
              return queue;
            })
            .push(function(){
              return gadget.state.server_model_gadget.add_doc_to_index("scolaire", "scolaire");
            })
            .push(function(){
              return gadget.state.client_model_gadget.download_new_index("scolaire");
            });
        }
      });
  })
 
  .declareMethod("search", function (key){
    var gadget = this;
    return gadget.state.result_gadget.clear()
      .push(function(){
        return gadget.state.client_model_gadget.search_in_index("scolaire", key);
      })
      .push(function(result){
        if (result.length === 0) {
            return gadget.state.result_gadget.addItem({
              title : "No results found",
              link : ""
            }, "");
        } else {
          var i, promise_list = [];
          for (i=0; i<result.length; i+=1){
            promise_list.push(gadget.state.result_gadget.addItem(result[i].doc, key));
          }
          return RSVP.all(promise_list);
        }
      });
  })
  
  .declareMethod("add_searx_results", function(key){
    var gadget = this;
    return new RSVP.Queue()
      .push(function(){
        return jIO.util.ajax({url : "https://cors-anywhere.herokuapp.com/search.disroot.org/?q=" + key + "&category_general=on&theme=oscar&language=fr"});
      })
      .push(function(resultHTML){
        var i,
            promise_list = [],
            elements,
            doc = new DOMParser().parseFromString(resultHTML.currentTarget.response, "text/html");
        elements = doc.body.querySelectorAll('div.result.result-default');
        for (i=0; i<elements.length; i+=1){
          promise_list.push(gadget.state.result_gadget.show_searx_result(elements[i], key));
        }
        return RSVP.all(promise_list);
      });
  })

  .onEvent("submit", function(event){
    var gadget = this;
    return gadget.search(event.target.elements[0].value)
      .push(function(){
        return gadget.add_searx_results(event.target.elements[0].value);
      });
  });

}(window, document, rJS, RSVP));
